/**
 * @license
 * Copyright 2020 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@tensorflow/tfjs-core"),require("seedrandom")):"function"==typeof define&&define.amd?define(["exports","@tensorflow/tfjs-core","seedrandom"],e):e((t=t||self).tf=t.tf||{},t.tf,t.seedrandom)}(this,(function(t,e,r){"use strict";function a(t,r,a,n){for(var o=e.util.getTypedArrayFromDType(n,e.util.sizeFromShape(a)),i=0;i<o.length;++i){for(var s=i*r,d=t[s],h=0;h<r;++h){var p=t[s+h];p>d&&(d=p)}o[i]=d}return o}function n(t,r,a,n,o){for(var i=r.length,s=e.util.sizeFromShape(r),d=e.util.computeStrides(r),h=e.util.computeStrides(o),p=e.util.getTypedArrayFromDType(a,e.util.sizeFromShape(o)),u=0;u<s;++u){for(var f=e.util.indexToLoc(u,i,d),l=new Array(f.length),c=0;c<l.length;c++)l[c]=f[n[c]];p[e.util.locToIndex(l,i,h)]=t[u]}return p}var o={__proto__:null,maxImpl:a,transposeImpl:n},i=function(t,e){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var r in e)e.hasOwnProperty(r)&&(t[r]=e[r])})(t,e)};function s(t,e,r,a){return new(r||(r=Promise))((function(n,o){function i(t){try{d(a.next(t))}catch(t){o(t)}}function s(t){try{d(a.throw(t))}catch(t){o(t)}}function d(t){var e;t.done?n(t.value):(e=t.value,e instanceof r?e:new r((function(t){t(e)}))).then(i,s)}d((a=a.apply(t,e||[])).next())}))}function d(t,e){var r,a,n,o,i={label:0,sent:function(){if(1&n[0])throw n[1];return n[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(r)throw new TypeError("Generator is already executing.");for(;i;)try{if(r=1,a&&(n=2&o[0]?a.return:o[0]?a.throw||((n=a.return)&&n.call(a),0):a.next)&&!(n=n.call(a,o[1])).done)return n;switch(a=0,n&&(o=[2&o[0],n.value]),o[0]){case 0:case 1:n=o;break;case 4:return i.label++,{value:o[1],done:!1};case 5:i.label++,a=o[1],o=[0];continue;case 7:o=i.ops.pop(),i.trys.pop();continue;default:if(!(n=i.trys,(n=n.length>0&&n[n.length-1])||6!==o[0]&&2!==o[0])){i=0;continue}if(3===o[0]&&(!n||o[1]>n[0]&&o[1]<n[3])){i.label=o[1];break}if(6===o[0]&&i.label<n[1]){i.label=n[1],n=o;break}if(n&&i.label<n[2]){i.label=n[2],i.ops.push(o);break}n[2]&&i.ops.pop(),i.trys.pop();continue}o=e.call(t,i)}catch(t){o=[6,t],a=0}finally{r=n=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}}function h(t,r){Array.isArray(t)||(t=[t]),t.forEach((function(t){null!=t&&e.util.assert("complex64"!==t.dtype,(function(){return r+" does not support complex64 tensors in the CPU backend."}))}))}function p(t,r,a,n,o,i){for(var s=o.strideHeight,d=o.strideWidth,h=o.dilationHeight,p=o.dilationWidth,u=o.effectiveFilterHeight,f=o.effectiveFilterWidth,l=o.padInfo.top,c=o.padInfo.left,v="max"===i?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,y=e.buffer(o.outShape,a),m=y.values,g=o.outShape[1]*o.outShape[2]*o.outShape[3],S=o.outShape[2]*o.outShape[3],I=o.outShape[3],b=0;b<o.batchSize;++b)for(var k=b*g,M=b*n[0],x=0;x<o.inChannels;++x)for(var A=0;A<o.outHeight;++A)for(var F=A*s-l,w=Math.max(0,F),T=Math.min(o.inHeight,u+F),D=k+A*S,z=0;z<o.outWidth;++z){for(var _=z*d-c,W=Math.max(0,_),O=Math.min(o.inWidth,f+_),H=v,N=0,B=0,C=w;C<T;C+=h){for(var E=M+C*n[1],P=W;P<O;P+=p){var R=t[E+P*n[2]+x];"max"===i&&R>H?H=R:"avg"===i&&(N+=R,B++)}if(isNaN(H))break}m[D+z*I+x]="avg"===i?N/B:H}return y}function u(t,r,a,n,o,i){void 0===o&&(o=!1),void 0===i&&(i=!1);for(var s=e.buffer(n.outShape,"int32"),d=n.strideHeight,h=n.strideWidth,p=n.dilationHeight,u=n.dilationWidth,f=n.effectiveFilterHeight,l=n.effectiveFilterWidth,c=n.padInfo.top,v=n.padInfo.left,y=e.buffer(r,a,t),m=0;m<n.batchSize;++m)for(var g=0;g<n.inChannels;++g)for(var S=0;S<n.outHeight;++S){for(var I=S*d-c,b=I;b<0;)b+=p;for(var k=Math.min(n.inHeight,f+I),M=0;M<n.outWidth;++M){for(var x=M*h-v,A=x;A<0;)A+=u;for(var F=Math.min(n.inWidth,l+x),w=Number.NEGATIVE_INFINITY,T=-1,D=b;D<k;D+=p)for(var z=D-I,_=A;_<F;_+=u){var W=_-x,O=y.get(m,D,_,g);O>w&&(w=O,T=o?i?((m*n.inHeight+D)*n.inWidth+_)*n.inChannels+g:(D*n.inWidth+_)*n.inChannels+g:z*l+W)}s.set(T,m,S,M,g)}}return s}var f=e.kernel_impls.nonMaxSuppressionV3,l=e.kernel_impls.split,c=e.kernel_impls.tile,v=e.kernel_impls.topkImpl,y=e.kernel_impls.whereImpl;function m(t,e,r,a){if("linear"===r)return t.linear(e);if("relu"===r)return t.relu(e);if("elu"===r)return t.elu(e);if("relu6"===r)return t.relu6(e);if("prelu"===r)return t.prelu(e,a);throw new Error("Activation "+r+" has not been implemented for the CPU backend.")}var g=function(t){function a(){var r=t.call(this)||this;return r.blockSize=48,r.firstUse=!0,r.data=new e.DataStorage(r,e.engine()),r}return function(t,e){function r(){this.constructor=t}i(t,e),t.prototype=null===e?Object.create(e):(r.prototype=e.prototype,new r)}(a,t),a.prototype.write=function(t,r,a){this.firstUse&&(this.firstUse=!1,e.env().get("IS_NODE")&&e.backend_util.warn("\n============================\nHi there 👋. Looks like you are running TensorFlow.js in Node.js. To speed things up dramatically, install our node backend, which binds to TensorFlow C++, by running npm i @tensorflow/tfjs-node, or npm i @tensorflow/tfjs-node-gpu if you have CUDA. Then call require('@tensorflow/tfjs-node'); (-gpu suffix for CUDA) at the start of your program. Visit https://github.com/tensorflow/tfjs-node for more details.\n============================"));var n={};return this.data.set(n,{values:t,dtype:a}),n},a.prototype.move=function(t,e,r,a){this.data.set(t,{values:e,dtype:a})},a.prototype.numDataIds=function(){return this.data.numDataIds()},a.prototype.read=function(t){return s(this,void 0,void 0,(function(){return d(this,(function(e){return[2,this.readSync(t)]}))}))},a.prototype.readSync=function(t){var r=this.data.get(t),a=r.dtype,n=r.complexTensors;if("complex64"===a){var o=this.readSync(n.real.dataId),i=this.readSync(n.imag.dataId);return e.backend_util.mergeRealAndImagArrays(o,i)}return this.data.get(t).values},a.prototype.bufferSync=function(t){var r=this.readSync(t.dataId),a=r;if("string"===t.dtype)try{a=r.map((function(t){return e.util.decodeString(t)}))}catch(t){throw new Error("Failed to decode encoded string bytes into utf-8")}return e.buffer(t.shape,t.dtype,a)},a.prototype.makeOutput=function(t,r,a){var n=this.write(t,r,a);return e.engine().makeTensorFromDataId(n,r,a,this)},a.prototype.disposeData=function(t){if(this.data.has(t)){var e=this.data.get(t).complexTensors;null!=e&&(e.real.dispose(),e.imag.dispose()),this.data.delete(t)}},a.prototype.time=function(t){return s(this,void 0,void 0,(function(){var r;return d(this,(function(a){return r=e.util.now(),t(),[2,{kernelMs:e.util.now()-r}]}))}))},a.prototype.memory=function(){return{unreliable:!0,reasons:["The reported memory is an upper bound. Due to automatic garbage collection, the true allocated memory may be less."]}},a.prototype.complex=function(t,r){var a=this.makeOutput(null,t.shape,"complex64");return this.data.get(a.dataId).complexTensors={real:e.engine().keep(t.clone()),imag:e.engine().keep(r.clone())},a},a.prototype.real=function(t){return this.data.get(t.dataId).complexTensors.real.clone()},a.prototype.imag=function(t){return this.data.get(t.dataId).complexTensors.imag.clone()},a.prototype.slice=function(t,r,a){if(h(t,"slice"),e.slice_util.isSliceContinous(t.shape,r,a)){var n=e.slice_util.computeFlatOffset(r,t.strides),o=e.util.sizeFromShape(a),i=this.readSync(t.dataId);return e.tensor(i.subarray(n,n+o),a,t.dtype)}for(var s=e.buffer(a,t.dtype),d=this.bufferSync(t),p=0;p<s.size;++p){var u=s.indexToLoc(p).map((function(t,e){return t+r[e]}));s.values[p]=d.get.apply(d,u)}return s.toTensor()},a.prototype.stridedSlice=function(t,r,a,n){h(t,"stridedSlice");var o=e.slice_util.computeOutShape(r,a,n);if(o.some((function(t){return 0===t})))return e.tensor([],o);for(var i=e.buffer(o,t.dtype),s=this.bufferSync(t),d=0;d<i.size;d++){for(var p=i.indexToLoc(d),u=new Array(p.length),f=0;f<u.length;f++)u[f]=p[f]*n[f]+r[f];i.set.apply(i,[s.get.apply(s,u)].concat(p))}return i.toTensor()},a.prototype.diag=function(t){for(var r=this.readSync(t.dataId),a=e.buffer([t.size,t.size],t.dtype),n=a.values,o=0;o<r.length;o++)n[o*t.size+o]=r[o];return a.toTensor()},a.prototype.unstack=function(t,e){for(var r=t.shape[e],a=new Array(t.rank-1),n=0,o=0;o<t.rank;o++)o!==e&&(a[n++]=t.shape[o]);var i=new Array(t.rank).fill(0),s=t.shape.slice();s[e]=1;var d=new Array(r);for(o=0;o<d.length;o++)i[e]=o,d[o]=this.slice(t,i,s).reshape(a);return d},a.prototype.reverse=function(t,r){h(t,"reverse");for(var a=e.buffer(t.shape,t.dtype),n=this.bufferSync(t),o=function(e){var o=a.indexToLoc(e),i=o.slice();r.forEach((function(e){return i[e]=t.shape[e]-1-i[e]})),a.set.apply(a,[n.get.apply(n,i)].concat(o))},i=0;i<a.size;i++)o(i);return a.toTensor()},a.prototype.concat=function(t,r){var a=this;if("complex64"===t[0].dtype){var n=t.map((function(t){return e.real(t)})),o=t.map((function(t){return e.imag(t)}));return e.complex(this.concat(n,r),this.concat(o,r))}var i=t.map((function(t){var a=e.util.sizeFromShape(t.shape.slice(r));return t.as2D(-1,a)})),s=e.backend_util.computeOutShape(i.map((function(t){return t.shape})),1),d=e.buffer(s,t[0].dtype).values;if(1===i[0].shape[0]){var h=0;i.forEach((function(t){d.set(a.readSync(t.dataId),h),h+=t.size}))}else{var p=0;i.forEach((function(t){for(var e=a.readSync(t.dataId),r=0,n=0;n<t.shape[0];++n)for(var o=n*s[1]+p,i=0;i<t.shape[1];++i)d[o+i]=e[r++];p+=t.shape[1]}))}var u=e.backend_util.computeOutShape(t.map((function(t){return t.shape})),r);return e.tensor(d,u,t[0].dtype)},a.prototype.neg=function(t){return h(t,"neg"),this.multiply(e.scalar(-1),t)},a.prototype.add=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t+r,imag:e+a}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t+e}))},a.prototype.addN=function(t){var r=this;h(t,"addN");for(var a=t.map((function(t){return r.readSync(t.dataId)})),n=e.buffer(t[0].shape,t[0].dtype),o=n.values,i=0;i<t.length;i++)for(var s=a[i],d=0;d<o.length;d++)o[d]+=s[d];return n.toTensor()},a.prototype.softmax=function(t,r){var a=e.util.parseAxisParam([r],t.shape),n=e.max(t,a),o=e.backend_util.expandShapeToKeepDim(n.shape,a),i=this.subtract(t,n.reshape(o)),s=this.exp(i),d=this.sum(s,a).reshape(o);return e.div(s,d)},a.prototype.subtract=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t-r,imag:e-a}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t-e}))},a.prototype.pow=function(t,e){return h([t,e],"pow"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.pow(t,e)}))},a.prototype.batchMatMul=function(t,r,a,n){h([t,r],"matMul");for(var o=a?t.shape[1]:t.shape[2],i=a?t.shape[2]:t.shape[1],s=n?r.shape[1]:r.shape[2],d=t.shape[0],p=this.readSync(t.dataId),u=this.readSync(r.dataId),f=a?[t.strides[0],1,t.strides[1]]:[t.strides[0],t.strides[1],1],l=f[0],c=f[1],v=f[2],y=n?[1,r.strides[1],r.strides[0]]:[r.strides[1],1,r.strides[0]],m=y[0],g=y[1],S=y[2],I=i*s,b=e.buffer([d,i,s],t.dtype),k=b.values,M=this.blockSize,x=0;x<d;x++)for(var A=0;A<i;A+=M)for(var F=0;F<s;F+=M)for(var w=0;w<o;w+=M)for(var T=Math.min(A+M,i),D=Math.min(F+M,s),z=Math.min(w+M,o),_=A;_<T;_++)for(var W=F;W<D;W++){for(var O=0,H=w;H<z;H++)O+=p[x*l+_*c+H*v]*u[H*m+W*g+x*S];k[x*I+(_*s+W)]+=O}return b.toTensor()},a.prototype.fusedBatchMatMul=function(t){var e=t.a,r=t.b,a=t.transposeA,n=t.transposeB,o=t.bias,i=t.activation,s=t.preluActivationWeights,d=this.batchMatMul(e,r,a,n);return o&&(d=this.add(d,o)),i&&(d=m(this,d,i,s)),d},a.prototype.multiply=function(t,r){return"complex64"===t.dtype||"complex64"===r.dtype?this.broadcastedBinaryComplexOp(t.cast("complex64"),r.cast("complex64"),(function(t,e,r,a){return{real:t*r-e*a,imag:t*a+e*r}})):this.broadcastedBinaryOp(t,r,e.upcastType(t.dtype,r.dtype),(function(t,e){return t*e}))},a.prototype.floorDiv=function(t,e){h([t,e],"floorDiv");return this.broadcastedBinaryOp(t,e,"int32",(function(t,e){return Math.floor(t/e)}))},a.prototype.sum=function(t,r){h(t,"sum"),e.backend_util.assertAxesAreInnerMostDims("sum",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.upcastType(t.dtype,"int32"),s=e.zeros(n,i),d=e.util.sizeFromShape(o),p=this.readSync(s.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*d,c=0,v=0;v<d;++v)c+=u[l+v];p[f]=c}return s},a.prototype.prod=function(t,r){h(t,"sum");for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.upcastType(t.dtype,"int32"),s=e.zeros(n,i),d=e.util.sizeFromShape(o),p=this.readSync(s.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*d,c=1,v=0;v<d;++v)c*=u[l+v];p[f]=c}return s},a.prototype.unsortedSegmentSum=function(t,r,a){h(t,"unsortedSegmentSum");for(var n=[],o=t.rank-r.rank,i=0;i<o;++i)r=r.expandDims(i+1);for(i=0;i<a;++i){var s=e.scalar(i,"int32"),d=e.equal(s,r).asType("float32").mul(t).sum(0);n.push(d)}return e.stack(n)},a.prototype.argMin=function(t,r){h(t,"argMin");var a=[r];e.backend_util.assertAxesAreInnerMostDims("argMin",a,t.rank);for(var n=e.backend_util.computeOutAndReduceShapes(t.shape,a),o=n[0],i=n[1],s=e.zeros(o,"int32"),d=e.util.sizeFromShape(i),p=this.readSync(s.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*d,c=u[l],v=0,y=0;y<d;++y){var m=u[l+y];m<c&&(c=m,v=y)}p[f]=v}return s},a.prototype.argMax=function(t,r){h(t,"argMax");var a=[r];e.backend_util.assertAxesAreInnerMostDims("argMax",a,t.rank);for(var n=e.backend_util.computeOutAndReduceShapes(t.shape,a),o=n[0],i=n[1],s=e.zeros(o,"int32"),d=e.util.sizeFromShape(i),p=this.readSync(s.dataId),u=this.readSync(t.dataId),f=0;f<p.length;++f){for(var l=f*d,c=u[l],v=0,y=0;y<d;++y){var m=u[l+y];m>c&&(c=m,v=y)}p[f]=v}return s},a.prototype.cumsum=function(t,r,a,n){if(h(t,"cumsum"),r!==t.rank-1)throw new Error("backend.cumsum in CPU expects an inner-most axis="+(t.rank-1)+" but got axis="+r);for(var o=e.upcastType(t.dtype,"int32"),i=e.zeros(t.shape,o),s=this.readSync(i.dataId),d=this.readSync(t.dataId),p=t.shape[t.rank-1],u=n?function(t,e){return t+p-e-1}:function(t,e){return t+e},f=0;f<d.length;f+=p)for(var l=0;l<p;l++){var c=u(f,l);if(0===l)s[c]=a?0:d[c];else{var v=u(f,l-1);s[c]=a?d[v]+s[v]:d[c]+s[v]}}return i},a.prototype.equal=function(t,e){return h([t,e],"equal"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t===e?1:0}))},a.prototype.notEqual=function(t,e){return h([t,e],"notEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t!==e?1:0}))},a.prototype.less=function(t,e){return h([t,e],"less"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<e?1:0}))},a.prototype.lessEqual=function(t,e){return h([t,e],"lessEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t<=e?1:0}))},a.prototype.greater=function(t,e){return h([t,e],"greater"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>e?1:0}))},a.prototype.greaterEqual=function(t,e){return h([t,e],"greaterEqual"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t>=e?1:0}))},a.prototype.logicalNot=function(t){h(t,"logicalNot");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)r[a]=e[a]?0:1;return this.makeOutput(r,t.shape,"bool")},a.prototype.logicalAnd=function(t,e){return h([t,e],"logicalAnd"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t&&e}))},a.prototype.logicalOr=function(t,e){return h([t,e],"logicalOr"),this.broadcastedBinaryOp(t,e,"bool",(function(t,e){return t||e}))},a.prototype.select=function(t,r,a){h([t,r,a],"select");for(var n=this.readSync(t.dataId),o=this.readSync(r.dataId),i=this.readSync(a.dataId),s=e.zeros(r.shape,e.upcastType(r.dtype,a.dtype)),d=this.readSync(s.dataId),p=0,u=0===t.rank||t.rank>1||1===r.rank?1:e.util.sizeFromShape(r.shape.slice(1)),f=0;f<n.length;f++)for(var l=0;l<u;l++)1===n[f]?d[p++]=o[f]:d[p++]=i[f];return s},a.prototype.where=function(t){h([t],"where");var e=this.readSync(t.dataId);return y(t.shape,e)},a.prototype.topk=function(t,e,r){h(t,"topk");var a=this.readSync(t.dataId);return v(a,t.shape,t.dtype,e,r)},a.prototype.min=function(t,r){h(t,"min"),e.backend_util.assertAxesAreInnerMostDims("min",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.zeros(n,t.dtype),s=e.util.sizeFromShape(o),d=this.readSync(i.dataId),p=this.readSync(t.dataId),u=0;u<d.length;++u){for(var f=u*s,l=p[f],c=0;c<s;++c){var v=p[f+c];v<l&&(l=v)}d[u]=l}return i},a.prototype.minimum=function(t,e){return h([t,e],"minimum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.min(t,e)}))},a.prototype.mod=function(t,e){return h([t,e],"mod"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var r=t%e;return t<0&&e<0||t>=0&&e>=0?r:(r+e)%e}))},a.prototype.maximum=function(t,e){return h([t,e],"maximum"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.max(t,e)}))},a.prototype.all=function(t,r){h(t,"all"),e.backend_util.assertAxesAreInnerMostDims("all",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.zeros(n,t.dtype),s=e.util.sizeFromShape(o),d=this.readSync(i.dataId),p=this.readSync(t.dataId),u=0;u<d.length;++u){for(var f=u*s,l=p[f],c=0;c<s;++c){var v=p[f+c];l=l&&v}d[u]=l}return i},a.prototype.any=function(t,r){h(t,"any"),e.backend_util.assertAxesAreInnerMostDims("any",r,t.rank);for(var a=e.backend_util.computeOutAndReduceShapes(t.shape,r),n=a[0],o=a[1],i=e.zeros(n,t.dtype),s=e.util.sizeFromShape(o),d=this.readSync(i.dataId),p=this.readSync(t.dataId),u=0;u<d.length;++u){for(var f=u*s,l=p[f],c=0;c<s;++c){var v=p[f+c];l=l||v}d[u]=l}return i},a.prototype.squaredDifference=function(t,e){return h([t,e],"squaredDifference"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){var r=t-e;return r*r}))},a.prototype.ceil=function(t){h(t,"ceil");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.ceil(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.floor=function(t){h(t,"floor");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.floor(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.sign=function(t){h(t,"x");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)e[a]<0?r[a]=-1:e[a]>0?r[a]=1:r[a]=0;return this.makeOutput(r,t.shape,"float32")},a.prototype.isNaN=function(t){h(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Number.isNaN(e[a])&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},a.prototype.isInf=function(t){h(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Math.abs(e[a])===1/0&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},a.prototype.isFinite=function(t){h(t,"x");for(var e=this.readSync(t.dataId),r=new Uint8Array(e.length),a=0;a<e.length;++a)Number.isFinite(e[a])&&(r[a]=1);return this.makeOutput(r,t.shape,"bool")},a.prototype.round=function(t){h(t,"round");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=Math.floor(e[a]);e[a]-n<.5?r[a]=Math.floor(e[a]):e[a]-n>.5?r[a]=Math.ceil(e[a]):r[a]=n%2==0?n:n+1}return this.makeOutput(r,t.shape,"float32")},a.prototype.exp=function(t){h(t,"exp");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.exp(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.expm1=function(t){h(t,"expm1");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=Math.expm1(e[a]);return this.makeOutput(r,t.shape,"float32")},a.prototype.log=function(t){h(t,"log");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.log(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.log1p=function(t){h(t,"log1p");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.log1p(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.sqrt=function(t){h(t,"sqrt");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=Math.sqrt(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.rsqrt=function(t){h(t,"rsqrt");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a){var n=e[a];r[a]=1/Math.sqrt(n)}return this.makeOutput(r,t.shape,"float32")},a.prototype.reciprocal=function(t){h(t,"reciprocal");for(var e=this.readSync(t.dataId),r=new Float32Array(e.length),a=0;a<e.length;++a)r[a]=1/e[a];return this.makeOutput(r,t.shape,"float32")},a.prototype.linear=function(t){return t},a.prototype.relu=function(t){h(t,"relu");for(var r=e.zeros(t.shape,t.dtype),a=this.readSync(r.dataId),n=this.readSync(t.dataId),o=0;o<n.length;++o)a[o]=Math.max(0,n[o]);return r},a.prototype.relu6=function(t){h(t,"relu");for(var r=e.zeros(t.shape,t.dtype),a=this.readSync(r.dataId),n=this.readSync(t.dataId),o=0;o<n.length;++o)a[o]=Math.min(Math.max(0,n[o]),6);return r},a.prototype.prelu=function(t,e){return h([t,e],"prelu"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return t<0?e*t:t}))},a.prototype.elu=function(t){h(t,"elu");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a){var n=r[a];e[a]=n>=0?n:Math.exp(n)-1}return this.makeOutput(e,t.shape,"float32")},a.prototype.eluDer=function(t,e){h([t,e],"eluDer");for(var r=new Float32Array(e.size),a=this.readSync(e.dataId),n=this.readSync(t.dataId),o=0;o<a.length;++o){var i=a[o];r[o]=i>=1?n[o]:n[o]*(i+1)}return this.makeOutput(r,e.shape,"float32")},a.prototype.selu=function(t){h(t,"selu");for(var r=e.backend_util.SELU_SCALEALPHA,a=e.backend_util.SELU_SCALE,n=new Float32Array(t.size),o=this.readSync(t.dataId),i=0;i<o.length;++i){var s=o[i];n[i]=s>=0?a*s:r*(Math.exp(s)-1)}return this.makeOutput(n,t.shape,"float32")},a.prototype.clip=function(t,e,r){h(t,"clip");for(var a=new Float32Array(t.size),n=this.readSync(t.dataId),o=0;o<n.length;++o){var i=n[o];a[o]=i>r?r:i<e?e:i}return this.makeOutput(a,t.shape,"float32")},a.prototype.abs=function(t){for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.abs(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.complexAbs=function(t){for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<t.size;++a){var n=r[2*a],o=r[2*a+1];e[a]=Math.hypot(n,o)}return this.makeOutput(e,t.shape,"float32")},a.prototype.int=function(t){h(t,"int");for(var e=new Int32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=r[a];return this.makeOutput(e,t.shape,"int32")},a.prototype.sigmoid=function(t){h(t,"sigmoid");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=1/(1+Math.exp(-r[a]));return this.makeOutput(e,t.shape,"float32")},a.prototype.softplus=function(t){h(t,"softplus");for(var e=Math.log(1.1920928955078125e-7)+2,r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n){var o=a[n]>-e,i=a[n]<e,s=Math.exp(a[n]),d=void 0;d=i?s:o?a[n]:Math.log(1+s),r[n]=d}return this.makeOutput(r,t.shape,"float32")},a.prototype.sin=function(t){h(t,"sin");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.sin(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.cos=function(t){h(t,"cos");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.cos(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.tan=function(t){h(t,"tan");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.tan(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.asin=function(t){h(t,"asin");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.asin(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.acos=function(t){h(t,"acos");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.acos(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.atan=function(t){h(t,"atan");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.atan(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.atan2=function(t,e){return h([t,e],"atan2"),this.broadcastedBinaryOp(t,e,t.dtype,(function(t,e){return Math.atan2(t,e)}))},a.prototype.sinh=function(t){h(t,"sinh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.sinh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.cosh=function(t){h(t,"cosh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.cosh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.tanh=function(t){h(t,"tanh");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n)r[n]=e.util.tanh(a[n]);return this.makeOutput(r,t.shape,"float32")},a.prototype.asinh=function(t){h(t,"asinh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.asinh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.acosh=function(t){h(t,"acosh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.acosh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.atanh=function(t){h(t,"atanh");for(var e=new Float32Array(t.size),r=this.readSync(t.dataId),a=0;a<r.length;++a)e[a]=Math.atanh(r[a]);return this.makeOutput(e,t.shape,"float32")},a.prototype.erf=function(t){h(t,"erf");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=e.backend_util.ERF_P,o=e.backend_util.ERF_A1,i=e.backend_util.ERF_A2,s=e.backend_util.ERF_A3,d=e.backend_util.ERF_A4,p=e.backend_util.ERF_A5,u=0;u<a.length;++u){var f=Math.sign(a[u]),l=Math.abs(a[u]),c=1/(1+n*l);r[u]=f*(1-((((p*c+d)*c+s)*c+i)*c+o)*c*Math.exp(-l*l))}return this.makeOutput(r,t.shape,"float32")},a.prototype.step=function(t,e){void 0===e&&(e=0),h(t,"step");for(var r=new Float32Array(t.size),a=this.readSync(t.dataId),n=0;n<a.length;++n){var o=a[n];isNaN(o)?r[n]=NaN:r[n]=o>0?1:e}return this.makeOutput(r,t.shape,"float32")},a.prototype.fusedConv2d=function(t){var e=t.input,r=t.filter,a=t.convInfo,n=t.bias,o=t.activation,i=t.preluActivationWeights,s=this.conv2d(e,r,a);return n&&(s=this.add(s,n)),o&&(s=m(this,s,o,i)),s},a.prototype.conv2d=function(t,r,a){h([t,r],"conv2d");for(var n=a.filterHeight,o=a.filterWidth,i=a.dilationHeight,s=a.dilationWidth,d=a.padInfo.left,p=a.padInfo.top,u="channelsLast"===a.dataFormat,f=e.buffer(a.outShape,t.dtype),l=t.strides[0],c=u?t.strides[1]:t.strides[2],v=u?t.strides[2]:1,y=u?1:t.strides[1],m=f.strides[0],g=u?f.strides[1]:f.strides[2],S=u?f.strides[2]:1,I=u?1:f.strides[1],b=this.readSync(t.dataId),k=this.readSync(r.dataId),M=f.values,x=0;x<a.batchSize;++x)for(var A=x*l,F=x*m,w=0;w<a.outHeight;++w)for(var T=F+w*g,D=w*a.strideHeight-p,z=0;z<n;z++){var _=D+z*i;if(!(_<0||_>=a.inHeight))for(var W=z*r.strides[0],O=A+_*c,H=0;H<a.outWidth;++H)for(var N=T+H*S,B=H*a.strideWidth-d,C=0;C<o;C++){var E=B+C*s;if(!(E<0||E>=a.inWidth))for(var P=O+E*v,R=W+C*r.strides[1],q=0;q<a.inChannels;++q){for(var L=b[P+q*y],U=0;U<a.outChannels;++U)M[N+U*I]+=L*k[R+U];R+=a.outChannels}}}return f.toTensor()},a.prototype.conv3d=function(t,r,a){for(var n=a.filterDepth,o=a.filterHeight,i=a.filterWidth,s=a.dilationDepth,d=a.dilationHeight,h=a.dilationWidth,p=a.padInfo.front,u=a.padInfo.left,f=a.padInfo.top,l=e.buffer(a.outShape,t.dtype),c=this.readSync(t.dataId),v=this.readSync(r.dataId),y=l.values,m=0;m<a.batchSize;++m)for(var g=m*t.strides[0],S=m*l.strides[0],I=0;I<a.outDepth;++I)for(var b=S+I*l.strides[1],k=I*a.strideDepth-p,M=0;M<n;M++){var x=k+M*s;if(!(x<0||x>=a.inDepth))for(var A=M*r.strides[0],F=g+x*t.strides[1],w=0;w<a.outHeight;++w)for(var T=b+w*l.strides[2],D=w*a.strideHeight-f,z=0;z<o;z++){var _=D+z*d;if(!(_<0||_>=a.inHeight))for(var W=A+z*r.strides[1],O=F+_*t.strides[2],H=0;H<a.outWidth;++H)for(var N=T+H*a.outChannels,B=H*a.strideWidth-u,C=0;C<i;C++){var E=B+C*h;if(!(E<0||E>=a.inWidth))for(var P=W+C*r.strides[2],R=O+E*a.inChannels,q=P,L=0;L<a.inChannels;++L){for(var U=c[R+L],j=0;j<a.outChannels;++j)y[N+j]+=U*v[q+j];q+=a.outChannels}}}}return l.toTensor()},a.prototype.conv2dDerInput=function(t,r,a){h([t,r],"conv2dDerInput");for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=this.readSync(t.dataId),s=this.readSync(r.dataId),d=r.strides,p=d[0],u=d[1],f=d[2],l=a.batchSize,c=a.filterHeight,v=a.filterWidth,y=a.inChannels,m=a.inHeight,g=a.inWidth,S=a.outChannels,I=a.outHeight,b=a.outWidth,k=a.strideHeight,M=a.strideWidth,x=a.dataFormat,A=c-1-a.padInfo.top,F=v-1-a.padInfo.left,w="channelsLast"===x,T=n.strides[0],D=w?n.strides[1]:n.strides[2],z=w?n.strides[2]:1,_=w?1:n.strides[1],W=t.strides[0],O=w?t.strides[1]:t.strides[2],H=w?t.strides[2]:1,N=w?1:t.strides[1],B=0;B<l;++B)for(var C=0;C<y;++C)for(var E=0;E<m;++E)for(var P=E-A,R=Math.max(0,Math.ceil(P/k)),q=Math.min(I,(c+P)/k),L=0;L<g;++L){for(var U=L-F,j=Math.max(0,Math.ceil(U/M)),G=Math.min(b,(v+U)/M),V=0,Y=R;Y<q;++Y)for(var K=Y*k-P,J=j;J<G;++J)for(var Q=W*B+O*Y+H*J,X=p*(c-1-K)+u*(v-1-(J*M-U))+f*C,Z=0;Z<S;++Z){V+=i[Q+N*Z]*s[X+Z]}o[T*B+D*E+z*L+_*C]=V}return n.toTensor()},a.prototype.conv3dDerInput=function(t,r,a){for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=n.strides,s=i[0],d=i[1],h=i[2],p=i[3],u=this.readSync(t.dataId),f=t.strides,l=f[0],c=f[1],v=f[2],y=f[3],m=this.readSync(r.dataId),g=r.strides,S=g[0],I=g[1],b=g[2],k=g[3],M=a.batchSize,x=a.filterDepth,A=a.filterHeight,F=a.filterWidth,w=a.inChannels,T=a.inDepth,D=a.inHeight,z=a.inWidth,_=a.outChannels,W=a.outDepth,O=a.outHeight,H=a.outWidth,N=a.strideDepth,B=a.strideHeight,C=a.strideWidth,E=x-1-a.padInfo.front,P=A-1-a.padInfo.top,R=F-1-a.padInfo.left,q=0;q<M;++q)for(var L=0;L<w;++L)for(var U=0;U<T;++U)for(var j=U-E,G=Math.max(0,Math.ceil(j/N)),V=Math.min(W,(x+j)/N),Y=0;Y<D;++Y)for(var K=Y-P,J=Math.max(0,Math.ceil(K/B)),Q=Math.min(O,(A+K)/B),X=0;X<z;++X){for(var Z=X-R,$=Math.max(0,Math.ceil(Z/C)),tt=Math.min(H,(F+Z)/C),et=0,rt=G;rt<V;++rt)for(var at=rt*N-j,nt=J;nt<Q;++nt)for(var ot=nt*B-K,it=$;it<tt;++it)for(var st=l*q+c*rt+v*nt+y*it,dt=S*(x-1-at)+I*(A-1-ot)+b*(F-1-(it*C-Z))+k*L,ht=0;ht<_;++ht){et+=u[st+ht]*m[dt+ht]}o[s*q+d*U+h*Y+p*X+L]=et}return n.toTensor()},a.prototype.conv2dDerFilter=function(t,r,a){h([t,r],"conv2dDerFilter");for(var n=a.strideHeight,o=a.strideWidth,i=a.filterHeight,s=a.filterWidth,d="channelsLast"===a.dataFormat,p=e.buffer(a.filterShape,"float32"),u=a.padInfo.left,f=a.padInfo.top,l=this.bufferSync(t),c=this.bufferSync(r),v=0;v<i;++v)for(var y=Math.max(0,Math.ceil((f-v)/n)),m=Math.min(a.outHeight,(a.inHeight+f-v)/n),g=0;g<s;++g)for(var S=Math.max(0,Math.ceil((u-g)/o)),I=Math.min(a.outWidth,(a.inWidth+u-g)/o),b=0;b<a.inChannels;++b)for(var k=0;k<a.outChannels;++k){for(var M=0,x=0;x<a.batchSize;++x)for(var A=y;A<m;++A)for(var F=v+A*n-f,w=S;w<I;++w){var T=g+w*o-u;M+=d?l.get(x,F,T,b)*c.get(x,A,w,k):l.get(x,b,F,T)*c.get(x,k,A,w)}p.set(M,v,g,b,k)}return p.toTensor()},a.prototype.conv3dDerFilter=function(t,r,a){for(var n=a.strideDepth,o=a.strideHeight,i=a.strideWidth,s=a.filterDepth,d=a.filterHeight,h=a.filterWidth,p=e.buffer(a.filterShape,"float32"),u=p.values,f=p.strides,l=f[0],c=f[1],v=f[2],y=f[3],m=this.readSync(r.dataId),g=r.strides,S=g[0],I=g[1],b=g[2],k=g[3],M=this.readSync(t.dataId),x=t.strides,A=x[0],F=x[1],w=x[2],T=x[3],D=a.padInfo.front,z=a.padInfo.left,_=a.padInfo.top,W=0;W<s;++W)for(var O=Math.max(0,Math.ceil((D-W)/n)),H=Math.min(a.outDepth,(a.inDepth+D-W)/n),N=W*l,B=0;B<d;++B)for(var C=Math.max(0,Math.ceil((_-B)/o)),E=Math.min(a.outHeight,(a.inHeight+_-B)/o),P=B*c+N,R=0;R<h;++R)for(var q=Math.max(0,Math.ceil((z-R)/i)),L=Math.min(a.outWidth,(a.inWidth+z-R)/i),U=R*v+P,j=0;j<a.inChannels;++j)for(var G=j*y+U,V=0;V<a.outChannels;++V){for(var Y=0,K=0;K<a.batchSize;++K)for(var J=K*A,Q=K*S,X=O;X<H;++X)for(var Z=(W+X*n-D)*F+J,$=X*I+Q,tt=C;tt<E;++tt)for(var et=(B+tt*o-_)*w+Z,rt=tt*b+$,at=q;at<L;++at){var nt=at*k+rt;Y+=M[(R+at*i-z)*T+et+j]*m[nt+V]}u[G+V]=Y}return p.toTensor()},a.prototype.fusedDepthwiseConv2D=function(t){var e=t.input,r=t.filter,a=t.convInfo,n=t.bias,o=t.activation,i=t.preluActivationWeights,s=this.depthwiseConv2D(e,r,a);return n&&(s=this.add(s,n)),o&&(s=m(this,s,o,i)),s},a.prototype.depthwiseConv2D=function(t,r,a){h([t,r],"depthwiseConv2D");for(var n=a.filterHeight,o=a.filterWidth,i=a.dilationHeight,s=a.dilationWidth,d=a.padInfo.left,p=a.padInfo.top,u=a.outChannels/a.inChannels,f=e.buffer(a.outShape,t.dtype),l=this.readSync(t.dataId),c=this.readSync(r.dataId),v=f.values,y=0;y<a.batchSize;++y)for(var m=y*t.strides[0],g=y*f.strides[0],S=0;S<a.outHeight;++S)for(var I=g+S*f.strides[1],b=S*a.strideHeight-d,k=0;k<n;++k){var M=b+k*i;if(!(M<0||M>=a.inHeight))for(var x=k*r.strides[0],A=m+M*t.strides[1],F=0;F<a.outWidth;++F)for(var w=I+F*f.strides[2],T=F*a.strideWidth-p,D=0;D<o;++D){var z=T+D*s;if(!(z<0||z>=a.inWidth))for(var _=x+D*r.strides[1],W=A+z*a.inChannels,O=w,H=_,N=0;N<a.inChannels;++N){for(var B=l[W+N],C=0;C<u;++C)v[O+C]+=B*c[H+C];O+=u,H+=u}}}return f.toTensor()},a.prototype.depthwiseConv2DDerInput=function(t,r,a){h([t,r],"depthwiseConv2DDerInput");for(var n=e.buffer(a.inShape,"float32"),o=n.values,i=n.strides,s=i[0],d=i[1],p=i[2],u=this.readSync(t.dataId),f=t.strides,l=f[0],c=f[1],v=f[2],y=this.readSync(r.dataId),m=r.strides,g=m[0],S=m[1],I=m[2],b=a.batchSize,k=a.filterHeight,M=a.filterWidth,x=a.inChannels,A=a.inHeight,F=a.inWidth,w=a.outChannels,T=a.outHeight,D=a.outWidth,z=a.strideHeight,_=a.strideWidth,W=k-1-a.padInfo.top,O=M-1-a.padInfo.left,H=w/x,N=0;N<b;++N)for(var B=0;B<x;++B)for(var C=0;C<A;++C)for(var E=C-W,P=Math.max(0,Math.ceil(E/z)),R=Math.min(T,(k+E)/z),q=0;q<F;++q){for(var L=q-O,U=Math.max(0,Math.ceil(L/_)),j=Math.min(D,(M+L)/_),G=0,V=P;V<R;++V)for(var Y=V*z-E,K=U;K<j;++K)for(var J=l*N+c*V+v*K,Q=g*(k-1-Y)+S*(M-1-(K*_-L))+I*B,X=0;X<H;++X){G+=u[J+(B*H+X)]*y[Q+X]}o[s*N+d*C+p*q+B]=G}return n.toTensor()},a.prototype.depthwiseConv2DDerFilter=function(t,r,a){h([t,r],"depthwiseConv2DDerFilter");for(var n=a.strideHeight,o=a.strideWidth,i=a.filterHeight,s=a.filterWidth,d=e.buffer(a.filterShape,"float32"),p=a.padInfo.left,u=a.padInfo.top,f=a.outChannels/a.inChannels,l=this.bufferSync(t),c=this.bufferSync(r),v=0;v<i;++v)for(var y=Math.max(0,Math.ceil((u-v)/n)),m=Math.min(a.outHeight,(a.inHeight+u-v)/n),g=0;g<s;++g)for(var S=Math.max(0,Math.ceil((p-g)/o)),I=Math.min(a.outWidth,(a.inWidth+p-g)/o),b=0;b<a.outChannels;++b){for(var k=Math.trunc(b/f),M=b%f,x=0,A=0;A<a.batchSize;++A)for(var F=y;F<m;++F)for(var w=v+F*n-u,T=S;T<I;++T){var D=g+T*o-p;x+=l.get(A,w,D,k)*c.get(A,F,T,b)}d.set(x,v,g,k,M)}return d.toTensor()},a.prototype.tile=function(t,e){return h(t,"tile"),c(this.bufferSync(t),e)},a.prototype.pad=function(t,r,a){h(t,"pad");var n=r.map((function(e,r){return e[0]+t.shape[r]+e[1]})),o=r.map((function(t){return t[0]})),i=this.bufferSync(t),s=e.buffer(n,t.dtype);0!==a&&s.values.fill(a);for(var d=0;d<t.size;d++){var p=i.indexToLoc(d),u=p.map((function(t,e){return t+o[e]}));s.set.apply(s,[i.get.apply(i,p)].concat(u))}return s.toTensor()},a.prototype.gather=function(t,r,a){h([t,r],"gather");var n=t.shape.slice(),o=this.readSync(r.dataId);n[a]=o.length;for(var i=e.buffer(n,t.dtype),s=this.bufferSync(t),d=0;d<i.size;++d){var p=i.indexToLoc(d),u=p.slice();u[a]=o[p[a]];var f=s.locToIndex(u);i.values[d]=s.values[f]}return i.toTensor()},a.prototype.batchToSpaceND=function(t,r,a){h([t],"batchToSpaceND");var n=r.reduce((function(t,e){return t*e})),o=e.backend_util.getReshaped(t.shape,r,n),i=e.backend_util.getPermuted(o.length,r.length),s=e.backend_util.getReshapedPermuted(t.shape,r,n),d=e.backend_util.getSliceBeginCoords(a,r.length),p=e.backend_util.getSliceSize(s,a,r.length);return e.transpose(t.reshape(o),i).reshape(s).slice(d,p)},a.prototype.spaceToBatchND=function(t,r,a){h([t],"spaceToBatchND");var n=r.reduce((function(t,e){return t*e})),o=[[0,0]];o.push.apply(o,a);for(var i=1+r.length;i<t.shape.length;++i)o.push([0,0]);var s=t.pad(o),d=e.backend_util.getReshaped(s.shape,r,n,!1),p=e.backend_util.getPermuted(d.length,r.length,!1),u=e.backend_util.getReshapedPermuted(s.shape,r,n,!1);return e.transpose(s.reshape(d),p).reshape(u)},a.prototype.maxPool=function(t,e){return h(t,"maxPool"),p(this.readSync(t.dataId),t.shape,t.dtype,t.strides,e,"max").toTensor()},a.prototype.maxPoolBackprop=function(t,r,a,n){h([r,a],"maxPoolBackprop");for(var o=this.readSync(r.dataId),i=e.buffer(n.outShape,r.dtype,u(o,r.shape,r.dtype,n).values),s=n.strideHeight,d=n.strideWidth,p=n.dilationHeight,f=n.dilationWidth,l=n.effectiveFilterHeight,c=n.effectiveFilterWidth,v=c-1-n.padInfo.left,y=l-1-n.padInfo.top,m=e.buffer(r.shape,"float32"),g=this.bufferSync(t),S=0;S<n.batchSize;++S)for(var I=0;I<n.inChannels;++I)for(var b=0;b<n.inHeight;++b)for(var k=0;k<n.inWidth;++k){for(var M=b-y,x=k-v,A=0,F=0;F<l;F+=p){var w=(M+F)/s;if(!(w<0||w>=n.outHeight||Math.floor(w)!==w))for(var T=0;T<c;T+=f){var D=(x+T)/d;if(!(D<0||D>=n.outWidth||Math.floor(D)!==D)){var z=l*c-1-i.get(S,w,D,I)===F*c+T?1:0;if(0!==z)A+=g.get(S,w,D,I)*z}}}m.set(A,S,b,k,I)}return m.toTensor()},a.prototype.avgPoolBackprop=function(t,r,a){h([t,r],"avgPoolBackprop");for(var n=a.strideHeight,o=a.strideWidth,i=a.filterHeight,s=a.filterWidth,d=a.dilationHeight,p=a.dilationWidth,u=a.effectiveFilterHeight,f=a.effectiveFilterWidth,l=f-1-a.padInfo.left,c=u-1-a.padInfo.top,v=e.buffer(r.shape,"float32"),y=1/(i*s),m=this.bufferSync(t),g=0;g<a.batchSize;++g)for(var S=0;S<a.inChannels;++S)for(var I=0;I<a.inHeight;++I)for(var b=0;b<a.inWidth;++b){for(var k=I-c,M=b-l,x=0,A=0;A<u;A+=d){var F=(k+A)/n;if(!(F<0||F>=a.outHeight||Math.floor(F)!==F))for(var w=0;w<f;w+=p){var T=(M+w)/o;if(!(T<0||T>=a.outWidth||Math.floor(T)!==T))x+=m.get(g,F,T,S)}}v.set(x*y,g,I,b,S)}return v.toTensor()},a.prototype.pool3d=function(t,r,a){h(t,"pool3d");for(var n=r.strideDepth,o=r.strideHeight,i=r.strideWidth,s=r.dilationDepth,d=r.dilationHeight,p=r.dilationWidth,u=r.effectiveFilterDepth,f=r.effectiveFilterHeight,l=r.effectiveFilterWidth,c=r.padInfo.front,v=r.padInfo.top,y=r.padInfo.left,m="max"===a?Number.NEGATIVE_INFINITY:Number.POSITIVE_INFINITY,g=this.readSync(t.dataId),S=e.buffer(r.outShape,t.dtype),I=S.values,b=r.outShape[1]*r.outShape[2]*r.outShape[3]*r.outShape[4],k=r.outShape[2]*r.outShape[3]*r.outShape[4],M=r.outShape[3]*r.outShape[4],x=r.outShape[4],A=0;A<r.batchSize;++A)for(var F=A*b,w=A*t.strides[0],T=0;T<r.inChannels;++T)for(var D=0;D<r.outDepth;++D){for(var z=D*n-c,_=z;_<0;)_+=s;for(var W=Math.min(r.inDepth,u+z),O=F+D*k,H=0;H<r.outHeight;++H){for(var N=H*o-v,B=N;B<0;)B+=d;for(var C=Math.min(r.inHeight,f+N),E=O+H*M,P=0;P<r.outWidth;++P){for(var R=P*i-y,q=R;q<0;)q+=p;for(var L=Math.min(r.inWidth,l+R),U=E+P*x,j=m,G=0,V=0,Y=_;Y<W;Y+=s){for(var K=w+Y*t.strides[1],J=B;J<C;J+=d){for(var Q=K+J*t.strides[2],X=q;X<L;X+=p){var Z=g[Q+X*t.strides[3]+T];if("max"===a&&Z>j?j=Z:"avg"===a&&(G+=Z,V++),isNaN(j))break}if(isNaN(j))break}if(isNaN(j))break}I[U+T]="avg"===a?G/V:j}}}return S.toTensor()},a.prototype.avgPool3d=function(t,e){return h(t,"avgPool3d"),this.pool3d(t,e,"avg").toFloat()},a.prototype.avgPool3dBackprop=function(t,r,a){h([t,r],"avgPool3dBackprop");for(var n=a.strideDepth,o=a.strideHeight,i=a.strideWidth,s=a.filterDepth,d=a.filterHeight,p=a.filterWidth,u=a.dilationDepth,f=a.dilationHeight,l=a.dilationWidth,c=a.effectiveFilterDepth,v=a.effectiveFilterHeight,y=a.effectiveFilterWidth,m=c-1-a.padInfo.front,g=y-1-a.padInfo.left,S=v-1-a.padInfo.top,I=e.buffer(r.shape,"float32"),b=1/(s*d*p),k=this.bufferSync(t),M=0;M<a.batchSize;++M)for(var x=0;x<a.inChannels;++x)for(var A=0;A<a.inDepth;++A)for(var F=0;F<a.inHeight;++F)for(var w=0;w<a.inWidth;++w){for(var T=A-m,D=F-S,z=w-g,_=0,W=0;W<c;W+=u){var O=(T+W)/n;if(!(O<0||O>=a.outDepth||Math.floor(O)!==O))for(var H=0;H<v;H+=f){var N=(D+H)/o;if(!(N<0||N>=a.outHeight||Math.floor(N)!==N))for(var B=0;B<y;B+=l){var C=(z+B)/i;if(!(C<0||C>=a.outWidth||Math.floor(C)!==C))_+=k.get(M,O,N,C,x)}}}I.set(_*b,M,A,F,w,x)}return I.toTensor()},a.prototype.maxPool3d=function(t,e){return h(t,"maxPool3d"),this.pool3d(t,e,"max").toFloat()},a.prototype.maxPool3dPositions=function(t,r){for(var a=e.buffer(r.outShape,"int32"),n=r.strideDepth,o=r.strideHeight,i=r.strideWidth,s=r.dilationDepth,d=r.dilationHeight,h=r.dilationWidth,p=r.effectiveFilterDepth,u=r.effectiveFilterHeight,f=r.effectiveFilterWidth,l=r.padInfo.front,c=r.padInfo.top,v=r.padInfo.left,y=this.bufferSync(t),m=0;m<r.batchSize;++m)for(var g=0;g<r.inChannels;++g)for(var S=0;S<r.outDepth;++S){for(var I=S*n-l,b=I;b<0;)b+=s;for(var k=Math.min(r.inDepth,p+I),M=0;M<r.outHeight;++M){for(var x=M*o-c,A=x;A<0;)A+=d;for(var F=Math.min(r.inHeight,u+x),w=0;w<r.outWidth;++w){for(var T=w*i-v,D=T;D<0;)D+=h;for(var z=Math.min(r.inWidth,f+T),_=Number.NEGATIVE_INFINITY,W=-1,O=b;O<k;O+=s)for(var H=O-I,N=A;N<F;N+=d)for(var B=N-x,C=D;C<z;C+=h){var E=C-T,P=y.get(m,O,N,C,g);P>=_&&(_=P,W=H*u*f+B*u+E)}a.set(W,m,S,M,w,g)}}}return a.toTensor()},a.prototype.maxPool3dBackprop=function(t,r,a,n){h([r,a],"maxPool3dBackprop");for(var o=this.maxPool3dPositions(r,n),i=n.strideDepth,s=n.strideHeight,d=n.strideWidth,p=n.dilationDepth,u=n.dilationHeight,f=n.dilationWidth,l=n.effectiveFilterDepth,c=n.effectiveFilterHeight,v=n.effectiveFilterWidth,y=l-1-n.padInfo.front,m=v-1-n.padInfo.left,g=c-1-n.padInfo.top,S=e.buffer(r.shape,"float32"),I=this.bufferSync(o),b=this.bufferSync(t),k=0;k<n.batchSize;++k)for(var M=0;M<n.inChannels;++M)for(var x=0;x<n.inDepth;++x)for(var A=0;A<n.inHeight;++A)for(var F=0;F<n.inWidth;++F){for(var w=x-y,T=A-g,D=F-m,z=0,_=0;_<l;_+=p){var W=(w+_)/i;if(!(W<0||W>=n.outDepth||Math.floor(W)!==W))for(var O=0;O<c;O+=u){var H=(T+O)/s;if(!(H<0||H>=n.outHeight||Math.floor(H)!==H))for(var N=0;N<v;N+=f){var B=(D+N)/d;if(!(B<0||B>=n.outWidth||Math.floor(B)!==B)){var C=l*c*v-1-I.get(k,W,H,B,M)===_*c*v+O*v+N?1:0;if(0!==C)z+=b.get(k,W,H,B,M)*C}}}}S.set(z,k,x,A,F,M)}return S.toTensor()},a.prototype.cast=function(t,r){return e.backend_util.castTensor(t,r,this)},a.prototype.reshape=function(t,r){return e.backend_util.reshapeTensor(t,r)},a.prototype.avgPool=function(t,e){return h(t,"avgPool"),h(t,"maxPool"),p(this.readSync(t.dataId),t.shape,t.dtype,t.strides,e,"avg").toTensor().toFloat()},a.prototype.resizeBilinear=function(t,r,a,n){h(t,"resizeBilinear");for(var o=t.shape,i=o[0],s=o[1],d=o[2],p=o[3],u=this.readSync(t.dataId),f=new Float32Array(e.util.sizeFromShape([i,r,a,p])),l=[n&&r>1?s-1:s,n&&a>1?d-1:d],c=[n&&r>1?r-1:r,n&&a>1?a-1:a],v=0,y=l[0]/c[0],m=l[1]/c[1],g=0;g<i;g++)for(var S=0;S<r;S++)for(var I=y*S,b=Math.floor(I),k=I-b,M=Math.min(s-1,Math.ceil(I)),x=g*t.strides[0]+b*t.strides[1],A=g*t.strides[0]+M*t.strides[1],F=0;F<a;F++)for(var w=m*F,T=Math.floor(w),D=w-T,z=Math.min(d-1,Math.ceil(w)),_=x+T*t.strides[2],W=A+T*t.strides[2],O=x+z*t.strides[2],H=A+z*t.strides[2],N=0;N<p;N++){var B=u[_+N],C=u[W+N],E=B+(u[O+N]-B)*D,P=E+(C+(u[H+N]-C)*D-E)*k;f[v++]=P}return e.tensor(f,[i,r,a,p])},a.prototype.resizeBilinearBackprop=function(t,r,a){h([t,r],"resizeBilinearBackprop");for(var n=r.shape,o=n[0],i=n[1],s=n[2],d=n[3],p=t.shape,u=p[1],f=p[2],l=new Float32Array(o*i*s*d),c=[a&&u>1?i-1:i,a&&f>1?s-1:s],v=[a&&u>1?u-1:u,a&&f>1?f-1:f],y=c[0]/v[0],m=c[1]/v[1],g=this.readSync(t.dataId),S=0,I=0;I<o;I++)for(var b=I*r.strides[0],k=0;k<u;k++)for(var M=k*y,x=Math.floor(M),A=Math.min(Math.ceil(M),i-1),F=b+x*r.strides[1],w=b+A*r.strides[1],T=M-x,D=1-T,z=0;z<f;z++)for(var _=z*m,W=Math.floor(_),O=Math.min(Math.ceil(_),s-1),H=_-W,N=1-H,B=F+W*r.strides[2],C=F+O*r.strides[2],E=w+W*r.strides[2],P=w+O*r.strides[2],R=D*N,q=D*H,L=T*N,U=T*H,j=0;j<d;j++){var G=g[S++];l[B+j]+=G*R,l[C+j]+=G*q,l[E+j]+=G*L,l[P+j]+=G*U}return e.tensor4d(l,[o,s,i,d],r.dtype)},a.prototype.resizeNearestNeighbor=function(t,r,a,n){h(t,"resizeNearestNeighbor");for(var o=t.shape,i=o[0],s=o[1],d=o[2],p=o[3],u=this.readSync(t.dataId),f=new Float32Array(i*r*a*p),l=[n&&r>1?s-1:s,n&&a>1?d-1:d],c=[n&&r>1?r-1:r,n&&a>1?a-1:a],v=l[0]/c[0],y=l[1]/c[1],m=0,g=0;g<i;g++)for(var S=g*t.strides[0],I=0;I<r;I++)for(var b=v*I,k=S+Math.min(s-1,n?Math.round(b):Math.floor(b))*t.strides[1],M=0;M<a;M++)for(var x=y*M,A=k+Math.min(d-1,n?Math.round(x):Math.floor(x))*t.strides[2],F=0;F<p;F++){var w=u[A+F];f[m++]=w}return e.tensor(f,[i,r,a,p],t.dtype)},a.prototype.resizeNearestNeighborBackprop=function(t,r,a){h([t,r],"resizeNearestNeighborBackprop");for(var n=r.shape,o=n[0],i=n[1],s=n[2],d=n[3],p=t.shape,u=p[1],f=p[2],l=new Float32Array(o*i*s*d),c=this.readSync(t.dataId),v=[a&&u>1?i-1:i,a&&f>1?s-1:s],y=[a&&u>1?u-1:u,a&&f>1?f-1:f],m=v[0]/y[0],g=v[1]/y[1],S=1/m,I=1/g,b=2*Math.ceil(S)+2,k=2*Math.ceil(I)+2,M=0;M<o;M++)for(var x=M*r.strides[0],A=0;A<i;A++)for(var F=x+A*r.strides[1],w=Math.floor(A*S),T=Math.floor(w-b/2),D=0;D<s;D++)for(var z=F+D*r.strides[2],_=Math.floor(D*I),W=Math.floor(_-k/2),O=0;O<d;O++){for(var H=0,N=0;N<b;N++){var B=N+T;if(!(B<0||B>=u)){var C=x+B*t.strides[1],E=B*m;if(A===Math.min(i-1,a?Math.round(E):Math.floor(E)))for(var P=0;P<k;P++){var R=P+W;if(!(R<0||R>=f)){var q=C+R*t.strides[2],L=R*g;D===Math.min(s-1,a?Math.round(L):Math.floor(L))&&(H+=c[q+O])}}}}l[z+O]=H}return e.tensor4d(l,r.shape,r.dtype)},a.prototype.batchNorm=function(t,r,a,n,o,i){h([t,r,a,o,n],"batchNorm");for(var s=this.readSync(t.dataId),d=this.readSync(r.dataId),p=this.readSync(a.dataId),u=o?this.readSync(o.dataId):new Float32Array([1]),f=n?this.readSync(n.dataId):new Float32Array([0]),l=new Float32Array(s.length),c=f.length,v=u.length,y=p.length,m=d.length,g=0,S=0,I=0,b=0,k=0;k<s.length;++k)l[k]=f[g++]+(s[k]-d[S++])*u[I++]/Math.sqrt(p[b++]+i),g>=c&&(g=0),S>=m&&(S=0),I>=v&&(I=0),b>=y&&(b=0);return e.tensor4d(l,t.shape)},a.prototype.localResponseNormalization4D=function(t,r,a,n,o){h(t,"localResponseNormalization4D");var i=t.shape[3],s=i-1,d=this.readSync(t.dataId),p=t.size,u=new Float32Array(p);function f(t){for(var e=t%i,a=t-e+Math.max(0,e-r),n=t-e+Math.min(e+r,s),o=0;a<=n;a++){var h=d[a];o+=h*h}return o}for(var l=0;l<p;l++){var c=f(l),v=d[l]*Math.pow(a+n*c,-o);u[l]=v}return e.tensor4d(u,t.shape)},a.prototype.LRNGrad=function(t,r,a,n,o,i,s){h(t,"LRNGrad");for(var d=t.shape[3],p=this.readSync(t.dataId),u=this.readSync(r.dataId),f=this.readSync(a.dataId),l=new Float32Array(t.size),c=t.size,v=0;v<c;v++){for(var y=v%d,m=v-y+Math.max(0,y-n),g=v-y+Math.min(d,y+n+1),S=0,I=m;I<g;I++)S+=Math.pow(u[I],2);S=i*S+o;for(I=m;I<g;I++){var b=-2*i*s*u[I]*f[v]/S;v===I&&(b+=Math.pow(S,-s)),b*=p[v],l[I]+=b}}return e.tensor4d(l,t.shape)},a.prototype.multinomial=function(t,a,n,o){h(t,"multinomial");for(var i=a?t:e.softmax(t),s=i.shape[0],d=i.shape[1],p=e.zeros([s,n],"int32"),u=this.readSync(p.dataId),f=this.readSync(i.dataId),l=0;l<s;++l){var c=l*d,v=new Float32Array(d-1);v[0]=f[c];for(var y=1;y<v.length;++y)v[y]=v[y-1]+f[c+y];for(var m=r.alea(o.toString()),g=l*n,S=0;S<n;++S){var I=m();u[g+S]=v.length;for(var b=0;b<v.length;b++)if(I<v[b]){u[g+S]=b;break}}}return p},a.prototype.oneHot=function(t,r,a,n){h(t,"oneHot");var o=new Float32Array(t.size*r);o.fill(n);for(var i=this.readSync(t.dataId),s=0;s<t.size;++s)i[s]>=0&&i[s]<r&&(o[s*r+i[s]]=a);return e.tensor2d(o,[t.size,r],"int32")},a.prototype.nonMaxSuppression=function(t,e,r,a,n){h(t,"nonMaxSuppression");var o=this.readSync(t.dataId),i=this.readSync(e.dataId);return f(o,i,r,a,n)},a.prototype.fft=function(t){return this.fftBatch(t,!1)},a.prototype.ifft=function(t){return this.fftBatch(t,!0)},a.prototype.fftBatch=function(t,r){for(var a=t.shape[0],n=t.shape[1],o=e.buffer(t.shape,"float32"),i=e.buffer(t.shape,"float32"),s=e.real(t).as2D(a,n),d=e.imag(t).as2D(a,n),h=0;h<a;h++)for(var p=s.slice([h,0],[1,n]),u=d.slice([h,0],[1,n]),f=e.complex(p,u),l=this.readSync(this.fftImpl(f,r).dataId),c=0;c<n;c++){var v=e.backend_util.getComplexWithIndex(l,c);o.values[h*n+c]=v.real,i.values[h*n+c]=v.imag}return e.complex(o.toTensor(),i.toTensor()).as2D(a,n)},a.prototype.fftImpl=function(t,r){var a=t.as1D(),n=a.size;if(this.isExponentOf2(n)){var o=this.fftRadix2(a,n,r).as2D(t.shape[0],t.shape[1]);return r&&(o=e.complex(e.real(o).div(e.scalar(n)),e.imag(o).div(e.scalar(n)))),o}var i=this.readSync(t.dataId),s=this.fourierTransformByMatmul(i,n,r),d=e.backend_util.splitRealAndImagArrays(s);return e.complex(d.real,d.imag).as2D(t.shape[0],t.shape[1])},a.prototype.isExponentOf2=function(t){return 0==(t&t-1)},a.prototype.fftRadix2=function(t,r,a){if(1===r)return t;var n=this.readSync(t.dataId),o=r/2,i=e.backend_util.complexWithEvenIndex(n),s=e.complex(i.real,i.imag).as1D(),d=e.backend_util.complexWithOddIndex(n),h=e.complex(d.real,d.imag).as1D();s=this.fftRadix2(s,o,a),h=this.fftRadix2(h,o,a);var p=e.backend_util.exponents(r,a),u=e.complex(p.real,p.imag).mul(h),f=s.add(u),l=s.sub(u),c=e.real(f).concat(e.real(l)),v=e.imag(f).concat(e.imag(l));return e.complex(c,v).as1D()},a.prototype.fourierTransformByMatmul=function(t,r,a){for(var n=new Float32Array(2*r),o=0;o<r;o++){for(var i=0,s=0,d=0;d<r;d++){var h=e.backend_util.exponent(o*d,r,a),p=e.backend_util.getComplexWithIndex(t,d);i+=p.real*h.real-p.imag*h.imag,s+=p.real*h.imag+p.imag*h.real}a&&(i/=r,s/=r),e.backend_util.assignToTypedArray(n,i,s,o)}return n},a.prototype.depthToSpace=function(t,r,a){e.util.assert("NHWC"===a,(function(){return"Only NHWC dataFormat supported on CPU for depthToSpace. Got "+a})),e.util.assert(r>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+r}));for(var n=t.shape[0],o=t.shape[1],i=t.shape[2],s=t.shape[3],d=o*r,h=i*r,p=s/(r*r),u=this.readSync(t.dataId),f=new Float32Array(n*d*h*p),l=0,c=0;c<n;++c)for(var v=0;v<d;++v)for(var y=Math.floor(v/r),m=v%r,g=0;g<h;++g)for(var S=Math.floor(g/r),I=(m*r+g%r)*p,b=0;b<p;++b){var k=b+I+s*(S+i*(y+o*c));f[l++]=u[k]}return e.tensor4d(f,[n,d,h,p])},a.prototype.broadcastedBinaryOp=function(t,r,a,n){var o=e.backend_util.assertAndGetBroadcastShape(t.shape,r.shape),i=e.buffer(o,a),s=this.readSync(t.dataId),d=this.readSync(r.dataId),h=e.backend_util.getBroadcastDims(t.shape,o),p=e.backend_util.getBroadcastDims(r.shape,o),u=i.values;if(h.length+p.length===0)for(var f=0;f<u.length;++f)u[f]=n(s[f%s.length],d[f%d.length]);else{var l=this.bufferSync(t),c=this.bufferSync(r),v=function(e){var a=i.indexToLoc(e),o=a.slice(-t.rank);h.forEach((function(t){return o[t]=0}));var f=l.locToIndex(o),v=a.slice(-r.rank);p.forEach((function(t){return v[t]=0}));var y=c.locToIndex(v);u[e]=n(s[f],d[y])};for(f=0;f<u.length;++f)v(f)}return i.toTensor()},a.prototype.broadcastedBinaryComplexOp=function(t,r,a){var n=e.backend_util.assertAndGetBroadcastShape(t.shape,r.shape),o=e.buffer(n,"float32"),i=e.buffer(n,"float32"),s=this.readSync(t.dataId),d=this.readSync(r.dataId),h=e.backend_util.getBroadcastDims(t.shape,n),p=e.backend_util.getBroadcastDims(r.shape,n),u=o.values,f=i.values;if(h.length+p.length===0)for(var l=0;l<u.length;l++){var c=l%s.length,v=l%d.length,y=a(s[2*c],s[2*c+1],d[2*v],d[2*v+1]);u[l]=y.real,f[l]=y.imag}else{var m=this.bufferSync(this.data.get(t.dataId).complexTensors.real),g=this.bufferSync(this.data.get(r.dataId).complexTensors.real),S=function(e){var n=o.indexToLoc(e),i=n.slice(-t.rank);h.forEach((function(t){return i[t]=0}));var l=m.locToIndex(i),c=n.slice(-r.rank);p.forEach((function(t){return c[t]=0}));var v=g.locToIndex(c),y=a(s[2*l],s[2*l+1],d[2*v],d[2*v+1]);u[e]=y.real,f[e]=y.imag};for(l=0;l<u.length;l++)S(l)}return this.complex(o.toTensor(),i.toTensor())},a.prototype.split=function(t,e,r){return l(t,e,r)},a.prototype.dispose=function(){},a.prototype.floatPrecision=function(){return 32},a.prototype.epsilon=function(){return t.prototype.epsilon.call(this)},a.prototype.cropAndResize=function(t,r,a,n,o,i){for(var s=t.shape,d=s[0],h=s[1],p=s[2],u=s[3],f=r.shape[0],l=n[0],c=n[1],v=e.buffer([f,l,c,u],"float32"),y=this.readSync(r.dataId),m=this.readSync(a.dataId),g=this.readSync(t.dataId),S=t.strides,I=v.strides,b=0;b<f;b++){var k=4*b,M=y[k],x=y[k+1],A=y[k+2],F=y[k+3],w=m[b];if(!(w>=d))for(var T=l>1?(A-M)*(h-1)/(l-1):0,D=c>1?(F-x)*(p-1)/(c-1):0,z=0;z<l;z++){var _=l>1?M*(h-1)+z*T:.5*(M+A)*(h-1);if(_<0||_>h-1)for(var W=0;W<c;W++)for(var O=0;O<u;O++){var H=O+W*I[2]+z*I[1]+b*I[0];v.values[H]=i}else if("bilinear"===o){var N=Math.floor(_),B=Math.ceil(_),C=_-N;for(W=0;W<c;W++){if((V=c>1?x*(p-1)+W*D:.5*(x+F)*(p-1))<0||V>p-1)for(O=0;O<u;O++){H=O+W*I[2]+z*I[1]+b*I[0];v.values[H]=i}else{var E=Math.floor(V),P=Math.ceil(V),R=V-E;for(O=0;O<u;O++){var q=g[H=O+E*S[2]+N*S[1]+w*S[0]],L=g[H=O+P*S[2]+N*S[1]+w*S[0]],U=g[H=O+E*S[2]+B*S[1]+w*S[0]],j=q+(L-q)*R,G=U+(g[H=O+P*S[2]+B*S[1]+w*S[0]]-U)*R;H=O+W*I[2]+z*I[1]+b*I[0],v.values[H]=j+(G-j)*C}}}}else for(W=0;W<c;++W){var V;if((V=c>1?x*(p-1)+W*D:.5*(x+F)*(p-1))<0||V>p-1)for(O=0;O<u;O++){H=O+W*I[2]+z*I[1]+b*I[0];v.values[H]=i}else{var Y=Math.round(V),K=Math.round(_);for(O=0;O<u;O++){var J=O+Y*S[2]+K*S[1]+w*S[0],Q=O+W*I[2]+z*I[1]+b*I[0];v.values[Q]=g[J]}}}}}return v.toTensor()},a.prototype.sparseToDense=function(t,r,a,n){var o=e.backend_util.calculateShapes(r,t,a),i=o.sliceRank,s=o.numUpdates,d=o.sliceSize,h=o.strides,p=o.outputSize;return this.scatter(t,r,a,p,d,s,i,h,n,!1)},a.prototype.gatherND=function(t,r){var a=r.shape,n=a[a.length-1],o=e.backend_util.prepareAndValidate(t,r),i=o[0],s=o[1],d=o[2],h=o[3];if(0===s)return e.tensor([],i,t.dtype);for(var p=new e.TensorBuffer([s,d],t.dtype),u=this.readSync(r.dataId),f=this.readSync(t.dataId),l=0;l<s;l++){for(var c=[],v=0,y=0;y<n;y++){var m=u[l*n+y];v+=m*h[y],c.push(m)}if(v<0||v>=t.size/d)throw new Error("Invalid indices: "+c+" does not index into "+t.shape);for(var g=0;g<d;g++)p.values[l*d+g]=f[v*d+g]}return p.toTensor().reshape(i)},a.prototype.scatterND=function(t,r,a){var n=e.backend_util.calculateShapes(r,t,a),o=n.sliceRank,i=n.numUpdates,s=n.sliceSize,d=n.strides,h=n.outputSize,p=e.scalar(0);return this.scatter(t,r,a,h,s,i,o,d,p,!0)},a.prototype.fill=function(t,r,a){a=a||e.util.inferDtype(r);var n=e.util.getArrayFromDType(a,e.util.sizeFromShape(t));return n.fill(r),e.engine().makeTensor(n,t,a,this)},a.prototype.onesLike=function(t){if("string"===t.dtype)throw new Error("onesLike is not supported for string tensors");return this.fill(t.shape,1,t.dtype)},a.prototype.zerosLike=function(t){var r=e.util.getArrayFromDType(t.dtype,e.util.sizeFromShape(t.shape));return this.makeOutput(r,t.shape,t.dtype)},a.prototype.linspace=function(t,r,a){return e.backend_util.linspaceImpl(t,r,a)},a.prototype.scatter=function(t,r,a,n,o,i,s,d,h,p){var u=[n/o,o],f=this.readSync(t.dataId),l=this.readSync(r.dataId);if(0===n)return e.tensor([],a,r.dtype);var c=new e.TensorBuffer(u,r.dtype);c.values.fill(this.readSync(h.dataId)[0]);for(var v=0;v<i;v++){for(var y=[],m=0,g=0;g<s;g++){var S=f[v*s+g];y.push(S),m+=S*d[g]}if(m<0||m>=n/o)throw new Error("Invalid indices: "+y+" does not index into "+a);for(var I=0;I<o;I++)p?c.values[m*o+I]+=l[v*o+I]:c.values[m*o+I]=0===r.rank?l[0]:l[v*o+I]}return c.toTensor().reshape(a)},a}(e.KernelBackend);function S(t,e){return{kernelName:t,backendName:"cpu",kernelFunc:function(r){var a=r.inputs,n=r.backend,o=a,i=o.a,s=o.b,d=n;h([i,s],t);var p=d.data.get(i.dataId).values,u=d.data.get(s.dataId).values,f=e(i.shape,s.shape,p,u,i.dtype),l=f[0],c=f[1];return{dataId:d.write(l,c,i.dtype),shape:c,dtype:i.dtype}}}}function I(t){return function(r,a,n,o,i){var s=e.backend_util.assertAndGetBroadcastShape(r,a),d=s.length,h=e.util.computeStrides(s),p=e.util.sizeFromShape(s),u=e.util.getTypedArrayFromDType(i,p),f=r.length,l=a.length,c=e.util.computeStrides(r),v=e.util.computeStrides(a),y=e.backend_util.getBroadcastDims(r,s),m=e.backend_util.getBroadcastDims(a,s);if(y.length+m.length===0)for(var g=0;g<u.length;++g)u[g]=t(n[g%n.length],o[g%o.length]);else{var S=function(r){var a=e.util.indexToLoc(r,d,h),i=a.slice(-f);y.forEach((function(t){return i[t]=0}));var s=e.util.locToIndex(i,f,c),p=a.slice(-l);m.forEach((function(t){return p[t]=0}));var g=e.util.locToIndex(p,l,v);u[r]=t(n[s],o[g])};for(g=0;g<u.length;++g)S(g)}return[u,s]}}var b=I((function(t,e){return t/e})),k=S(e.Div,b),M={kernelName:e.Max,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,o=t.attrs,i=t.backend,s=r.x,d=o.reductionIndices,p=i,u=s.shape,f=u.length,l=e.util.parseAxisParam(d,u),c=e.backend_util.getAxesPermutation(l,f),v=p.data.get(s.dataId).values;if(null!=c){for(var y=new Array(f),m=0;m<y.length;m++)y[m]=u[c[m]];v=n(v,u,s.dtype,c,y),l=e.backend_util.getInnerMostAxes(l.length,f),u=y}h(s,"max"),e.backend_util.assertAxesAreInnerMostDims("max",l,f);var g=e.backend_util.computeOutAndReduceShapes(u,l),S=g[0],I=g[1],b=a(v,e.util.sizeFromShape(I),S,s.dtype);return{dataId:p.write(b,S,s.dtype),shape:S,dtype:s.dtype}}};for(var x={kernelName:e.MaxPoolWithArgmax,backendName:"cpu",kernelFunc:function(t){var r=t.inputs,a=t.attrs,n=t.backend,o=r.x,i=a,s=i.filterSize,d=i.strides,f=i.pad,l=i.includeBatchInIndex,c=n;h(o,"MaxPoolWithArgmax");var v=c.data.get(o.dataId).values,y=e.backend_util.computePool2DInfo(o.shape,s,d,[1,1],f),m=function(t,r,a,n,o){var i=p(t,0,a,e.util.computeStrides(r),o,"max"),s=u(t,r,a,o,!0,n);return[i.values,s.values]}(v,o.shape,o.dtype,l,y),g=m[0],S=m[1],I=c.write(g,y.outShape,o.dtype),b=c.write(S,y.outShape,o.dtype);return[{dataId:I,shape:y.outShape,dtype:o.dtype},{dataId:b,shape:y.outShape,dtype:"int32"}]}},A=e.kernel_impls.nonMaxSuppressionV5,F={kernelName:e.NonMaxSuppressionV5,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=t.attrs,n=e,o=n.boxes,i=n.scores,s=a,d=s.maxOutputSize,p=s.iouThreshold,u=s.scoreThreshold,f=s.softNmsSigma,l=r;h(o,"NonMaxSuppressionWithScore");var c=l.data.get(o.dataId).values,v=l.data.get(i.dataId).values,y=A(c,v,d,p,u,f);return[y.selectedIndices,y.selectedScores]}},w={kernelName:e.Square,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.backend,a=e.x,n=r;h(a,"square");for(var o=n.data.get(a.dataId).values,i=new Float32Array(o.length),s=0;s<o.length;++s){var d=o[s];i[s]=d*d}return{dataId:n.write(i,a.shape,a.dtype),shape:a.shape,dtype:a.dtype}}},T=I((function(t,e){var r=t-e;return r*r})),D=0,z=[F,w,S(e.SquaredDifference,T),k,{kernelName:e.Transpose,backendName:"cpu",kernelFunc:function(t){var e=t.inputs,r=t.attrs,a=t.backend,o=e.x,i=r.perm,s=a;h(o,"transpose");for(var d=o.shape.length,p=new Array(d),u=0;u<p.length;u++)p[u]=o.shape[i[u]];var f=n(s.data.get(o.dataId).values,o.shape,o.dtype,i,p);return{dataId:s.write(f,p,o.dtype),shape:p,dtype:o.dtype}}},x,M];D<z.length;D++){var _=z[D];e.registerKernel(_)}e.registerBackend("cpu",(function(){return new g}),1),t.MathBackendCPU=g,t.shared=o,t.version_cpu="2.0.0-rc.4",Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-backend-cpu.min.js.map
